
%% Extract impulse response
function [ir, idx1] = extract_ir_01(ir0, fs)

% ir0: impulse response data
% ir : extracted impulse response

% Ver. 1.0;   2014.02.10 TDU Y. Kaneda

% kaneda@c.dendai.ac.jp

%% -----------------------------------------

% ---  Set ir00 as a column vector
ir00=ir0; if_tp=0;
if size(ir00,1)<size(ir00,2); ir00 = ir00'; if_tp=1; end; 

% --- Late part extraction
icut2 = round(600/1000*fs);     % Extract late part during 600ms (tentative) after the maximum point


% --- Early part extraction
icut1 = round(20/1000*fs);      % Extract early part during 20ms (tentative) before the maximum point
[amax, idx] = max(ir00);          % Detect maximum point
ir3 = [ir00; ir00; ir00]; 
ir = ir3(length(ir00)+idx-icut1+1: length(ir00)+idx+icut2);
                                % Extraction (+1 makes the signal length to even number)
idx1 = idx-icut1+1;

% --- Post processing
if if_tp==1; ir = ir'; end                      % Align the ir in vector format of ir0

return